// Yes, this is a joke. Please don't send me emails about how stupid it is.

class RRboombox extends TournamentWeapon;

#exec mesh import mesh=boombox anivfile=Models\boombox_a.3d datafile=Models\boombox_d.3d x=0 y=0 z=0 mlod=0
#exec mesh origin mesh=boombox x=0 y=0 z=0
#exec mesh sequence mesh=boombox seq=All startframe=0 numframes=1

//Playerview
#exec mesh import mesh=boomboxP anivfile=Models\boomboxP_a.3d datafile=Models\boomboxP_d.3d x=0 y=0 z=0 mlod=0
#exec mesh origin mesh=boomboxP x=0 y=0 z=0
#exec mesh sequence mesh=boomboxP seq=All startframe=0 numframes=1
#exec MESH ORIGIN MESH=boomboxP X=-1 Y=-700 Z=0 YAW=25 PITCH=-10 ROLL=20

#exec meshmap new meshmap=boombox mesh=boombox
#exec meshmap scale meshmap=boombox x=0.05859 y=0.05859 z=0.11719

#exec meshmap new meshmap=boomboxP mesh=boomboxP
#exec meshmap scale meshmap=boomboxP x=0.05859 y=0.05859 z=0.11719

#exec AUDIO IMPORT FILE="Sounds\Ricky.wav" NAME="Ricky" GROUP="Looping"

#exec TEXTURE IMPORT NAME=boomtop FILE=TEXTURES\boomtop.bmp
#exec TEXTURE IMPORT NAME=boombox FILE=TEXTURES\boombox.bmp


var() float Range;
var() sound HitSound, DownSound, IdleSound;
var Playerpawn LastHit;


function Fire( float Value )
{
    GotoState('NormalFire');
    bPointing=True;
    bCanClientFire = true;
    Pawn(Owner).PlayRecoil(FiringSpeed);
    ClientFire(value);
    TraceFire(0.0);
}

simulated function PlayFiring()
{
    AmbientSound = HitSound;
    SoundVolume = 255;
}

state NormalFire
{
    ignores AnimEnd;

    function BeginState()
    {
        Super.BeginState();
        AmbientSound = HitSound;
        SoundVolume = 255;
    }
    function EndState()
    {
        AmbientSound = IdleSound;
        Super.EndState();
        SoundVolume = Default.SoundVolume;
    }

Begin:
    Sleep(0.15);
    if ( PlayerPawn(Owner) != None )
        PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
    TraceFire(0.0);
    Sleep(0.15);
    if ( PlayerPawn(Owner) != None )
        PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
    if ( LastHit != None )
    {
        LastHit.ClientFlash( -0.38, vect(530, 90, 90));
        LastHit.ShakeView(0.25, 600, 6);
    }
    if ( Pawn(Owner).bFire == 0 )
        Finish();
    Goto('Begin');
}

state ClientFiring
{
    simulated function AnimEnd()
    {
        AmbientSound = HitSound;
        SoundVolume = 255*Pawn(Owner).SoundDampening;
    }
    simulated function EndState()
    {
        AmbientSound = IdleSound;
        Super.EndState();
        SoundVolume = Default.SoundVolume;      
    }
}

simulated function bool ClientFire( float Value )
{
    if ( bCanClientFire )
    {
        Owner.PlayOwnedSound(HitSound, SLOT_Misc, 1.7*Pawn(Owner).SoundDampening);
        if ( Role < ROLE_Authority )
            GotoState('ClientFiring');
        return true;
    }
    return false;
}       

state Firing
{
    function AltFire(float F) 
    {
    }
    function Tick( float DeltaTime )
    {
        local vector Dest, Start;
        local Pawn P;
        local ScriptedPawn SP;

        if ( bChangeWeapon )
            GotoState('DownWeapon');
        P = Pawn(Owner);
        if ( P == None )
        {
            AmbientSound = None;
            GotoState('');
            return;
        }
        else
        {
            RRgib();
            PlayFiring();
            return;
        }
    }
}

function Finish()
{
    if ( PlayerPawn(Owner) == None )
    {
        if ( (Pawn(Owner).bFire != 0) && (FRand() < RefireRate) )
            Global.Fire(0);
        else if ( (Pawn(Owner).bAltFire != 0) && (FRand() < AltRefireRate) )
            Global.AltFire(0);  
        else 
        {
            Pawn(Owner).StopFiring();
            GotoState('Idle');
        }
        return;
    }
    if ( Pawn(Owner).bFire!=0 )
        Global.Fire(0);
    else if ( Pawn(Owner).bAltFire!=0 )
        Global.AltFire(0);
    else 
        GotoState('Idle');
}

function TraceFire(float accuracy)
{
    local vector HitLocation, HitNormal, EndTrace, X, Y, Z, Start;
    local actor Other;

    RRgib();
    LastHit = None;
    Owner.MakeNoise(Pawn(Owner).SoundDampening);
    GetAxes(Pawn(owner).ViewRotation, X, Y, Z);
    Start =  Owner.Location + CalcDrawOffset() + FireOffset.Y * Y + FireOffset.Z * Z;
    AdjustedAim = pawn(owner).AdjustAim(1000000, Start, 2 * AimError, False, False);    
    EndTrace = Owner.Location + (10 + Range) * vector(AdjustedAim);
    Other = Pawn(Owner).TraceShot(HitLocation, HitNormal, EndTrace, Start);

    if ( (Other == None) || (Other == Owner) || (Other == self) )
        return;
    Other.TakeDamage(20.0, Pawn(Owner), HitLocation, -15000 * X, MyDamageType);
    if ( !Other.bIsPawn && !Other.IsA('Carcass') )
        spawn(class'SawHit',,,HitLocation+HitNormal, Rotator(HitNormal));
    else if ( Other.IsA('PlayerPawn') && (Pawn(Other).Health > 0) )
        LastHit = PlayerPawn(Other);
}

simulated function PlayPostSelect()
{
    AmbientSound = IdleSound;
    if ( Level.NetMode == NM_Client )
    {
        Super.PlayPostSelect();
        return;
    }
}

function RRgib()
{
    local vector Start, HitLocation, X;
    local Pawn P;
    local ScriptedPawn SP;

    Start = Pawn(Owner).Location;
    foreach RadiusActors(class'ScriptedPawn', SP, 750, Start)
	{
		  if ( (SP != self) && (SP != None) )
                        SP.TakeDamage(10000, Pawn(Owner), HitLocation, 60000*X, MyDamageType);
                  return;
	}
}

defaultproperties
{
     ItemName="Boombox"
     bCanThrow=True
     FiringSpeed=1.000000
     FireOffset=(X=15.000000,Y=-13.000000,Z=-7.000000)
     AIRating=-1.000000
     FireSound=Sound'Botpack.Translocator.ThrowTarget'
     AltFireSound=Sound'Botpack.Translocator.ReturnTarget'
     DeathMessage="%k RickRolled %o!"
     AutoSwitchPriority=0
     PickupMessage="You got the Boombox. Get ROLLING!"
     RespawnTime=0.000000
     PlayerViewScale=0.4
     PlayerViewMesh=Mesh'RRboombox.boomboxP'
     PickupViewMesh=Mesh'RRboombox.boombox'
     ThirdPersonMesh=Mesh'RRboombox.boombox'
     StatusIcon=Texture'Botpack.Icons.UseTrans'
     Icon=Texture'Botpack.Icons.UseTrans'
     Mesh=Mesh'RRboombox.boombox'
     bNoSmooth=False
     CollisionRadius=30.000000
     CollisionHeight=15.000000
     Mass=10.000000
     MultiSkins(0)=Texture'boomtop'
     MultiSkins(1)=Texture'boombox'
     WeaponDescription="Boombox by gopo."
     HitSound=Sound'Ricky'  //Rick Astley FTW
     IdleSound=Sound'Botpack.Domination.WarningSound'
     MyDamageType=slashed
}
